' Script to sign files in a batch
' Ben Stokes (ben@ukstokes.com) 04-2010

' Edit the variable below. Use double quotes if your path contains spaces. i.e. ""C:\Program Files""

TestsignJar = "d:\Download\From_Inet\Samsung\Repack\Sign\testsign.jar"

' Nothing below this line needs to be changed
' ###########################################

Set oShell = CreateObject("WScript.Shell")
Set oFSO = CreateObject("Scripting.FileSystemObject")
WindowStyle_Hidden = 0
args = WScript.Arguments.Count

If args < 1 then
	msgbox "Incorrect usage - drag your files on to this script to sign them.", vbexclamation, "Incorrect usage" 
	wscript.quit
end If

'change the folder names into variables
Target = WScript.Arguments.Item(0)
ParentFolder = oFSO.GetParentFolderName(Target) 
TargetFileName = oFSO.GetFileName(Target)
SignedFilesFolder = ParentFolder & "\" & "SignedFiles"

If oFSO.FolderExists(SignedFilesFolder) Then
'folder exists
Else
 oFSO.CreateFolder(SignedFilesFolder)
End If

'Test if the output file exists already - thie section can be deleted if it is annoying
SignedFile = SignedFilesFolder & "\" & TargetFileName
If oFSO.FileExists(SignedFile) Then
	Continue = MsgBox (SignedFile & " already exists. Overwrite the file?",vbYesNo + VBQuestion, "File exists")
	If Continue = vbYes then
		oFSO.DeleteFile(SignedFile)
	Else		
		wscript.quit
	End If
End If 

'make a temp file to capture the output
sTempFile = oShell.ExpandEnvironmentStrings("%TEMP%") & "\" & oFSO.GetTempName
Const OpenAsASCII = 0
Const FailIfNotExist = 0
Const ForReading = 1
oFSO.CreateTextFile(sTempFile)
set fFile = oFSO.OpenTextFile(sTempFile, ForReading, FailIfNotExist, OpenAsASCII)

sExe = "java -classpath " & TestsignJar & " testsign " & """" & Target & """" & " " & """" & SignedFilesFolder & "\" & TargetFileName &  """"
oShell.run "%comspec% /c " & sExe & " > " & sTempFile & " 2>&1" , 0 , True

If oFSO.FileExists(SignedFilesFolder & "\" & TargetFileName) then
	msgbox "Created output file " & SignedFilesFolder & "\" & TargetFileName, vbinformation, "Creating signed file"
Else
	ErrorMsg = fFile.ReadLine
	fFile.Close
		if oFSO.FileExists(sTempFile) Then
		oFSO.DeleteFile(sTempFile)
	End If
	MsgBox "There was a problem signing " & TargetFileName & ":" & vbCRLF & vbCRLF & ErrorMsg, vbCritical , "Could not sign file"
End If	